%define name	ffmpeg
%define version	2.8.11

%define avcmajor 56
%define avclibname %mklibname avcodec %avcmajor
%define develname %mklibname %name -d
%define staticname %mklibname %name -s -d

%define avfmajor 56
%define avflibname %mklibname avformat %avfmajor

%define postprocmajor 53
%define postproclibname %mklibname postproc %postprocmajor

%define avumajor 54
%define avulibname %mklibname avutil %avumajor

%define swsmajor 3
%define swslibname %mklibname swscaler %swsmajor

%define filtermajor 5
%define filterlibname %mklibname avfilter %filtermajor

%define swresamplemajor 1
%define swresamplelibname %mklibname swresample %swresamplemajor


Name: 	 	%{name}
Version: 	%{version}
Release: 	%mkrel 4
Summary: 	Hyper fast MPEG1/MPEG4/H263/RV and AC3/MPEG audio encoder
URL:		http://ffmpeg.org/
Source0: 	http://ffmpeg.org/releases/%{name}-%{version}.tar.xz
Patch0:		ffmpeg-kodi-flush-hack.patch
License: 	GPLv3+
Group: 	 	Video
#---------------------------------------------
BuildRequires:	yasm
BuildRequires: frei0r-plugins-devel
BuildRequires: libtheora-devel
BuildRequires: texi2html
BuildRequires: x264-devel
BuildRequires: %{_lib}SDL-devel
BuildRequires: %{_lib}alsa2-devel
BuildRequires: %{_lib}ass-devel
BuildRequires: %{_lib}bzip2-devel
BuildRequires: %{_lib}cdio-devel
BuildRequires: %{_lib}celt-devel 
BuildRequires: %{_lib}crystalhd-devel
BuildRequires: %{_lib}dc1394-devel
BuildRequires: %{_lib}dirac-devel
BuildRequires: %{_lib}faac-devel
BuildRequires: %{_lib}freetype6-devel
BuildRequires: %{_lib}gmp-devel
BuildRequires: %{_lib}gnutls-devel
BuildRequires: %{_lib}gsm-devel
BuildRequires: %{_lib}jack-devel
BuildRequires: %{_lib}jpeg-devel
BuildRequires: %{_lib}lame0-devel
BuildRequires: %{_lib}lzo-devel
BuildRequires: %{_lib}modplug-devel
BuildRequires: %{_lib}nettle-devel
BuildRequires: %{_lib}nut-devel
BuildRequires: %{_lib}ogg-devel
BuildRequires: %{_lib}opencore-amrnb-devel
BuildRequires: %{_lib}opencore-amrwb-devel
BuildRequires: %{_lib}openjpeg1-devel
BuildRequires: %{_lib}opus-devel
BuildRequires: %{_lib}cdio-paranoia-devel
BuildRequires: %{_lib}png-devel
BuildRequires: %{_lib}pulseaudio-devel
BuildRequires: %{_lib}rtmp-devel
BuildRequires: %{_lib}schroedinger-devel
BuildRequires: %{_lib}speex1-devel
BuildRequires: %{_lib}twolame-devel
BuildRequires: %{_lib}v4l-devel
BuildRequires: %{_lib}va-devel
BuildRequires: %{_lib}vdpau-devel
BuildRequires: %{_lib}vo-aacenc-devel
BuildRequires: %{_lib}vo-amrwbenc-devel
BuildRequires: %{_lib}vorbis0-devel
BuildRequires: %{_lib}vpx-devel
BuildRequires: %{_lib}x11-devel
BuildRequires: %{_lib}xavs-devel
BuildRequires: %{_lib}xext-devel
BuildRequires: %{_lib}xfixes-devel
BuildRequires: %{_lib}xv-devel
BuildRequires: %{_lib}xvid4-devel
BuildRequires: %{_lib}xvmc-devel
BuildRequires: %{_lib}x265-devel
#---------------------------------------------
Requires:	%postproclibname = %version-%release
Requires:	%avclibname = %version-%release
Requires:	%avflibname = %version-%release
Requires:	%avulibname = %version-%release
Requires:	%filterlibname = %version-%release
Requires:       %{swslibname} = %{version}-%release
Requires:	%swresamplelibname = %{version}-%release
#---------------------------------------------

%description
ffmpeg is a hyper fast realtime audio/video encoder, a streaming server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.


%package -n %{avclibname}
Group:          System/Libraries
Summary:        Shared library part of ffmpeg
Provides:       libffmpeg = %{version}-%{release}
Obsoletes:	%{_lib}ffmpeg53 < 0.8.2-2

%description -n %{avclibname}
ffmpeg is a hyper fast realtime audio/video encoder, a streaming server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg if you want to encode multimedia streams.

%package -n %{postproclibname}
Group:          System/Libraries
Summary:        Shared library part of ffmpeg
Conflicts: 	%mklibname ffmpeg 51
Obsoletes:	%{_lib}postproc-extra52

%description -n %{postproclibname}
ffmpeg is a hyper fast realtime audio/video encoder, a streaming server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg if you want to encode multimedia streams.


%package -n %{avflibname}
Group:          System/Libraries
Summary:        Shared library part of ffmpeg
Obsoletes:	%{_lib}avformats53 < %{version}-%{release}

%description -n %{avflibname}
ffmpeg is a hyper fast realtime audio/video encoder, a streaming server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg if you want to encode multimedia streams.

%package -n %{avulibname}
Group:          System/Libraries
Summary:        Shared library part of ffmpeg

%description -n %{avulibname}
ffmpeg is a hyper fast realtime audio/video encoder, a streaming server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg if you want to encode multimedia streams.

%package -n %{swslibname}
Group:          System/Libraries
Summary:        Shared library part of ffmpeg
Obsoletes:	%{_lib}swscaler-extra2

%description -n %{swslibname}
ffmpeg is a hyper fast realtime audio/video encoder, a streaming server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg if you want to encode multimedia streams.

%package -n %{filterlibname}
Group:          System/Libraries
Summary:        Shared library part of ffmpeg
Obsoletes:	%{_lib}avfilter3 < %version-%release

%description -n %{filterlibname}
ffmpeg is a hyper fast realtime audio/video encoder, a streaming server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg if you want to encode multimedia streams.

%package -n %{swresamplelibname}
Group:		System/Libraries
Summary:	Shared library part of ffmpeg

%description -n %{swresamplelibname}
ffmpeg is a hyper fast realtime audio/video encoder, a streaming server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg if you want to encode multimedia streams.

%package -n %develname
Group:          Development/Libraries
Summary:        Header files for the ffmpeg codec library
Requires:       %{avclibname} = %{version}-%release
Requires:       %{avflibname} = %{version}-%release
Requires:       %{avulibname} = %{version}-%release
Requires:       %{postproclibname} = %{version}-%release
Requires:       %{swslibname} = %{version}-%release
Requires:	%{filterlibname} = %{version}-%release
Requires:	%{swresamplelibname} = %{version}-%release
Provides:       libffmpeg-devel = %{version}-%{release}
Provides:	ffmpeg-devel = %{version}-%{release}
Obsoletes: 	%mklibname -d %name 51

%description -n %develname
ffmpeg is a hyper fast realtime audio/video encoder, a streaming server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg-devel if you want to compile apps with ffmpeg support.

%package -n %staticname
Group:          Development/Libraries
Summary:        Static library for the ffmpeg codec library
Requires:       %develname = %{version}-%release
Provides:       libffmpeg-static-devel = %{version}-%{release}
Obsoletes: 	%mklibname -s -d %name 51

%description -n %staticname
ffmpeg is a hyper fast realtime audio/video encoder, a streaming server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg-devel if you want to compile apps with ffmpeg support.

%prep
%setup -q -n %{name}-%version
%apply_patches

%build
export CFLAGS="%optflags -FPIC"
export LDFLAGS="%{ldflags}"

./configure --prefix=%_prefix \
	--enable-shared \
	--libdir=%{_libdir} \
	--shlibdir=%{_libdir} \
	--incdir=%{_includedir} \
	--disable-stripping \
	--enable-postproc \
	--enable-gpl \
	--enable-pthreads \
	--enable-libtheora \
	--enable-libvorbis \
	--disable-encoder=vorbis \
	--enable-libvpx \
	--enable-x11grab \
	--enable-runtime-cpudetect \
	--enable-libdc1394 \
	--enable-libschroedinger \
	--enable-librtmp \
	--enable-libspeex \
	--enable-libfreetype \
	--enable-libnut \
	--enable-libgsm \
	--enable-libcelt \
	--enable-libopus \
	--disable-libopencv \
	--enable-libopenjpeg \
	--enable-libtwolame \
	--enable-libxavs \
	--enable-frei0r \
	--enable-libmodplug \
	--enable-libass \
	--enable-gnutls \
	--enable-libcdio \
	--enable-libpulse \
	--enable-libv4l2 \
	--enable-libmp3lame \
	--enable-libopencore-amrnb \
	--enable-libopencore-amrwb \
	--enable-version3 \
	--enable-libx264 \
	--enable-libx265 \
	--enable-libvo-aacenc \
	--enable-libvo-amrwbenc \
	--enable-libxvid \
	--enable-decoder=atrac3 \
	--enable-decoder=atrac3p \
	--enable-nonfree \
	--enable-libfaac

	
%make

%install
rm -rf %buildroot
%makeinstall_std SRC_PATH=`pwd`

%files
%doc doc/*.html doc/*.txt doc/*.conf
%{_bindir}/*
%{_mandir}/man1/*
%{_datadir}/ffmpeg

%files -n %{avclibname}
%{_libdir}/libavcodec.so.%{avcmajor}*

%files -n %postproclibname
%{_libdir}/libpostproc.so.%{postprocmajor}*

%files -n %{avflibname}
%{_libdir}/libavformat.so.%{avfmajor}*
%{_libdir}/libavdevice.so.%{avfmajor}*

%files -n %{avulibname}
%{_libdir}/libavutil.so.%{avumajor}*

%files -n %{swslibname}
%{_libdir}/libswscale.so.%{swsmajor}*

%files -n %{filterlibname}
%{_libdir}/libavfilter.so.%{filtermajor}*

%files -n %{swresamplelibname}
%{_libdir}/libswresample.so.%{swresamplemajor}*

%files -n %develname
%doc doc/APIchanges
%{_includedir}/libavcodec
%{_includedir}/libavdevice
%{_includedir}/libavfilter
%{_includedir}/libavformat
%{_includedir}/libavutil
%{_includedir}/libpostproc
%{_includedir}/libswscale
%{_includedir}/libswresample
%{_libdir}/libavcodec.so
%{_libdir}/libavdevice.so
%{_libdir}/libavformat.so
%{_libdir}/libavfilter.so
%{_libdir}/libavutil.so
%{_libdir}/libpostproc.so
%{_libdir}/libswscale.so
%{_libdir}/libswresample.so
%_libdir/pkgconfig/libswscale.pc
%_libdir/pkgconfig/libavcodec.pc
%_libdir/pkgconfig/libavdevice.pc
%_libdir/pkgconfig/libavfilter.pc
%_libdir/pkgconfig/libavformat.pc
%_libdir/pkgconfig/libavutil.pc
%_libdir/pkgconfig/libpostproc.pc
%_libdir/pkgconfig/libswresample.pc
%_mandir/man3/lib*.3*

%files -n %staticname
%{_libdir}/*.a

%changelog
* Tue Aug 15 2017 bb2 <bb2> - 2.8.11-4pclos2017
- rebuild against updates

* Sat Apr 22 2017 bb2 <bb2> 2.8.11-3pclos2017
- rebuild for updated gnutls

* Thu Feb 16 2017 bb <bb> 2.8.11-2pclos2017
- rebuild new x265

